var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);
var import_node_path4 = __toESM(require("path"), 1);
var import_debug = __toESM(require("debug"), 1);

// src/build.ts
var import_node_fs2 = __toESM(require("fs"), 1);
var import_node_path3 = __toESM(require("path"), 1);
var import_case_anything2 = require("case-anything");

// src/utils.ts
var import_node_path = __toESM(require("path"), 1);
var import_node_module = require("module");
var import_node_url = require("url");
var import_node_process = __toESM(require("process"), 1);
var import_fast_glob = __toESM(require("fast-glob"), 1);
var import_case_anything = require("case-anything");
var import_meta = {};
var nonNullable = (value) => {
  return value !== null && value !== void 0;
};
var dirname = typeof __dirname === "undefined" ? import_node_path.default.dirname((0, import_node_url.fileURLToPath)(import_meta.url)) : __dirname;
var OWN_DIR = import_node_path.default.join(dirname, "..");
var slash = (input) => input.replace(/\\/g, "/");
var resolveFrom = (id, dir) => {
  const req = typeof globalThis.require === "function" ? globalThis.require : (0, import_node_module.createRequire)(import_meta.url);
  const resolved = req.resolve(id, { paths: [dir] });
  return req(resolved);
};
var localRequire = (id) => {
  return resolveFrom(id, import_node_process.default.cwd());
};
async function getPagesFromOptions(options) {
  if (options.pages) {
    const watchFiles = /* @__PURE__ */ new Set();
    return {
      watchFiles,
      pages: await Promise.all(options.pages.map(async (page) => {
        const title = page.title || import_node_path.default.basename(page.component, import_node_path.default.extname(page.component));
        const exampleFiles2 = await (0, import_fast_glob.default)(page.examples, { absolute: true, onlyFiles: true });
        exampleFiles2.forEach((file) => {
          watchFiles.add(file);
        });
        watchFiles.add(import_node_path.default.resolve(page.component));
        return __spreadProps(__spreadValues({}, page), {
          title,
          examples: exampleFiles2
        });
      }))
    };
  }
  const { components, componentExamples } = options;
  if (!components || !componentExamples) {
    throw new Error("You must either provide `pages` or both `components` and `componentExamples` when configuring VitePlay");
  }
  const exampleFiles = await (0, import_fast_glob.default)(componentExamples, { absolute: true, onlyFiles: true }).then((items) => items.map((v) => slash(v)).sort());
  const componentFiles = await (0, import_fast_glob.default)(components, {
    absolute: true,
    onlyFiles: true,
    ignore: [componentExamples]
  }).then((items) => items.map((v) => slash(v)).sort());
  return {
    watchFiles: /* @__PURE__ */ new Set([...componentFiles, ...exampleFiles]),
    pages: componentFiles.map((p) => {
      const fileName = import_node_path.default.basename(p, import_node_path.default.extname(p));
      const folder = import_node_path.default.dirname(p);
      const folderName = import_node_path.default.basename(folder);
      if (folderName.toLowerCase() !== fileName.toLowerCase()) {
        return null;
      }
      const examples = exampleFiles.filter((_p) => _p.startsWith(folder + "/")).sort();
      return { title: fileName, component: p, examples };
    }).filter(nonNullable)
  };
}
var getIframeHtml = (iframeId, cacheDir) => `
<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body>
    <div id="app"></div>
    <script type="module" src="${slash(import_node_path.default.join(cacheDir, `__iframe/${iframeId}.js`))}"><\/script>
  </body>
</html>
`;
var resolveFile = async (files, cwd) => {
  const result = await (0, import_fast_glob.default)(files, { cwd, absolute: true, onlyFiles: true });
  return result[0];
};
var getEmptyDocsBlock = (code) => {
  const EMPTY_DOCS_BLOCK_RE = /^<docs\s+([^/>]+)\/?>(<\/docs>)?/m;
  const HTML_ATTR_RE = /(\w+)(?:="([^"]+)")?/g;
  const [, attrString] = EMPTY_DOCS_BLOCK_RE.exec(code) || [];
  if (attrString) {
    const attrs = {};
    attrString.replace(HTML_ATTR_RE, (_, key, value) => {
      attrs[key] = value === void 0 || value === "true" ? true : value === "false" ? false : value;
      return "";
    });
    return { attrs, component: code.replace(EMPTY_DOCS_BLOCK_RE, "") };
  }
};
var camelCaseKeys = (obj) => {
  const result = {};
  for (const key in obj) {
    result[(0, import_case_anything.camelCase)(key)] = obj[key];
  }
  return result;
};

// src/parse-example.ts
var parseExample = async (contents, file) => {
  const compiler = localRequire("vue/compiler-sfc");
  const sfc = compiler.parse(contents, { filename: file });
  const result = { imports: [], docs: { attrs: {}, content: "" }, component: contents };
  if (sfc.descriptor.script || sfc.descriptor.scriptSetup) {
    const scriptResult = compiler.compileScript(sfc.descriptor, {
      id: "foo",
      sourceMap: false
    });
    const imports = [];
    const extractImports = (ast) => {
      if (!ast)
        return;
      compiler.walk(ast, {
        enter(node) {
          if (node.type === "CallExpression" && node.callee.type === "Import") {
            const arg = node.arguments[0];
            if (arg.type !== "StringLiteral") {
              throw new Error(`Expected string literal for import, got ${arg.type}`);
            }
            imports.push({ source: arg.value });
          } else if (node.type === "ImportDeclaration") {
            for (const spec of node.specifiers) {
              imports.push({
                importDefault: spec.type === "ImportDefaultSpecifier",
                source: node.source.value
              });
            }
          }
        }
      });
    };
    extractImports(scriptResult.scriptSetupAst);
    extractImports(scriptResult.scriptAst);
    result.imports = imports;
  }
  const docsBlock = sfc.descriptor.customBlocks.find((block) => block.type === "docs");
  if (docsBlock) {
    result.docs.content = docsBlock.content;
    result.component = `${result.component.slice(0, docsBlock.loc.start.offset)}${result.component.slice(docsBlock.loc.end.offset)}`.replace(/<docs[^>]*><\/docs>/, "");
    result.docs.attrs = camelCaseKeys(docsBlock.attrs);
  } else {
    const emptyDocs = getEmptyDocsBlock(result.component);
    if (emptyDocs) {
      result.component = emptyDocs.component;
      result.docs.attrs = emptyDocs.attrs;
    }
  }
  result.component = result.component.trim();
  return result;
};

// src/fs.ts
var import_node_fs = __toESM(require("fs"), 1);
var import_node_path2 = __toESM(require("path"), 1);
var outputFileSync = (filepath, content) => {
  const dir = import_node_path2.default.dirname(filepath);
  ensureDirSync(dir);
  import_node_fs.default.writeFileSync(filepath, content);
};
var outputFileIfChanged = (filepath, content) => {
  if (import_node_fs.default.existsSync(filepath)) {
    const oldContent = import_node_fs.default.readFileSync(filepath, "utf8");
    if (oldContent === content) {
      return;
    }
  }
  outputFileSync(filepath, content);
};
var ensureDirSync = (dir) => {
  import_node_fs.default.mkdirSync(dir, { recursive: true });
};

// src/markdown.ts
var import_markdown_it = __toESM(require("markdown-it"), 1);
var renderMarkdown = (content) => {
  const md = new import_markdown_it.default();
  return md.render(content);
};

// src/parse-component.ts
var import_node_module2 = require("module");
var import_meta2 = {};
var require2 = (0, import_node_module2.createRequire)(import_meta2.url);
var generator = require2("@babel/generator");
var inferTsType = (node) => {
  if (node.type === "Identifier") {
    switch (node.name) {
      case "String":
        return "string";
      case "Number":
        return "number";
      case "Boolean":
        return "boolean";
      case "Object":
        return "object";
      case "Array":
        return "array";
      default:
        return node.name;
    }
  } else if (node.type === "TSAsExpression") {
    return generateCodeFromTypeAnnotation(node.typeAnnotation, "foo.ts");
  } else if (node.type === "ArrayExpression") {
    return node.elements.map((node2) => node2 ? inferTsType(node2) : null).filter(Boolean).join(" | ");
  }
  return "unknown";
};
var getDescFromComments = (comments) => {
  return comments ? comments.map((c) => c.value).join("\n").replace(/^\*/, "").replace(/^\s+\*\s+/gm, "").trim() : "";
};
var generateCodeFromTypeAnnotation = (node, file) => {
  return generator.default(node, {
    sourceFileName: file
  }).code;
};
var parseComponent = async (contents, file) => {
  const compiler = localRequire("vue/compiler-sfc");
  const sfc = compiler.parse(contents, { filename: file });
  const { scriptSetup, script } = sfc.descriptor;
  const props = [];
  const extractPropsFromPropsObject = (node) => {
    if (node.type !== "ObjectExpression")
      return;
    for (const prop of node.properties) {
      if (prop.type !== "ObjectProperty" || prop.key.type !== "Identifier")
        continue;
      const name = prop.key.name;
      let type = "any";
      let required = false;
      const desc = getDescFromComments(prop.leadingComments);
      if (prop.value.type === "Identifier") {
        type = inferTsType(prop.value);
      } else if (prop.value.type === "ObjectExpression") {
        for (const item of prop.value.properties) {
          if (item.type === "ObjectProperty" && item.key.type === "Identifier") {
            if (item.key.name === "type") {
              type = inferTsType(item.value);
            } else if (item.key.name === "required" && item.value.type === "BooleanLiteral") {
              required = item.value.value === true;
            }
          }
        }
      }
      props.push({
        name,
        type,
        required,
        desc
      });
    }
  };
  const parse = (code) => {
    const ast = compiler.babelParse(code, {
      sourceFilename: file,
      plugins: ["typescript"],
      sourceType: "module"
    });
    compiler.walk(ast, {
      enter(node) {
        var _a;
        if (node.type === "CallExpression" && node.callee.type === "Identifier" && node.callee.name === "defineProps") {
          this.skip();
          const typeParam = (_a = node.typeParameters) == null ? void 0 : _a.params[0];
          const firstArg = node.arguments && node.arguments[0];
          if ((typeParam == null ? void 0 : typeParam.type) === "TSTypeLiteral") {
            for (const member of typeParam.members) {
              if (member.type === "TSPropertySignature" && member.key.type === "Identifier" && member.typeAnnotation) {
                props.push({
                  name: member.key.name,
                  type: generateCodeFromTypeAnnotation(member.typeAnnotation.typeAnnotation, file),
                  desc: getDescFromComments(member.leadingComments),
                  required: !member.optional
                });
              }
            }
          } else if (firstArg && firstArg.type === "ObjectExpression") {
            extractPropsFromPropsObject(firstArg);
          }
        }
        if (node.type === "CallExpression" && node.callee.type === "Identifier" && node.callee.name === "defineComponent") {
          this.skip();
          const arg = node.arguments[0];
          if (arg && arg.type === "ObjectExpression") {
            const property = arg.properties[0];
            if (property && property.type === "ObjectProperty" && property.key.type === "Identifier" && property.key.name === "props") {
              extractPropsFromPropsObject(property.value);
            }
          }
        }
      }
    });
  };
  if (scriptSetup) {
    parse(scriptSetup.content);
  } else if (script) {
    parse(script.content);
  }
  return {
    props
  };
};

// src/build.ts
var build = async (options) => {
  const base = options.base ?? "/";
  const getPath = options.getPath ?? ((slug) => `${slug}`);
  const { pages: _pages, watchFiles } = await getPagesFromOptions(options);
  const iframes = [];
  const pages = await Promise.all(_pages.map(async (page, index) => {
    const { props } = await parseComponent(await import_node_fs2.default.promises.readFile(page.component, "utf8"), page.component).catch((error) => {
      if (error.loc && !error.loc.file) {
        error.loc.file = page.component;
      }
      throw error;
    });
    const componentName = import_node_path3.default.basename(page.component, import_node_path3.default.extname(page.component));
    const componentProps = {
      [componentName]: props
    };
    const examples = await Promise.all(page.examples.map(async (file) => {
      var _a, _b, _c;
      const contents2 = await import_node_fs2.default.promises.readFile(file, "utf8");
      const parsed = await parseExample(contents2, file).catch((error) => {
        if (error.loc && !error.loc.file) {
          error.loc.file = file;
        }
        throw error;
      });
      const title = ((_c = (_b = (_a = file.split("/").pop()) == null ? void 0 : _a.replace(/^\d+-/, "")) == null ? void 0 : _b.replace(/\.vue$/, "")) == null ? void 0 : _c.replace(/\.example$/, "")) ?? "";
      const slug2 = (0, import_case_anything2.kebabCase)(title);
      const iframeId = `${page.title}-${slug2}`;
      return {
        title,
        slug: slug2,
        absolutePath: import_node_path3.default.resolve(file),
        contents: parsed.component,
        parsed,
        iframeId,
        iframeFilePath: import_node_path3.default.join(options.cacheDir, `__iframe/${iframeId}.html`)
      };
    }));
    if (examples.length === 0) {
      console.warn(`No examples found for ${JSON.stringify(page)}`);
    }
    for (const example of examples) {
      const iframeComponentCode = `
        <script setup>
        import { IframePreview } from '@viteplay/vue/iframe'
        const code = decodeURI(${JSON.stringify(encodeURI(example.contents))})

        const modules = {}
        ${(example.parsed.imports || []).map((im, imIndex) => `import ${im.importDefault ? "" : "* as "} module_${imIndex} from "${slash(im.source.startsWith(".") ? import_node_path3.default.join(import_node_path3.default.dirname(example.absolutePath), im.source) : im.source)}"
          modules["${im.source}"] = module_${imIndex}
          `).join("\n")}
        <\/script>

        <template>
          <IframePreview :code="code" :modules="modules" />
        </template>
        `;
      const iframeAppCode = `
        import { createApp, h } from 'vue'
        import App from './${example.iframeId}.vue'
        import viteplayIframe from '../viteplay.iframe'

        const { Wrapper, extend } = viteplayIframe

        const app = createApp({
          setup() {
            return () => Wrapper ? h(Wrapper, () => [h(App)]) : h(App)
          }
        })
        if (extend) {
          extend({ app })
        }
        app.mount('#app')
        `;
      outputFileIfChanged(import_node_path3.default.join(options.cacheDir, `__iframe/${example.iframeId}.vue`), iframeComponentCode);
      outputFileIfChanged(import_node_path3.default.join(options.cacheDir, `__iframe/${example.iframeId}.js`), iframeAppCode);
      outputFileIfChanged(example.iframeFilePath, getIframeHtml(example.iframeId, options.cacheDir));
      iframes.push({
        id: example.iframeId,
        filepath: example.iframeFilePath
      });
    }
    const contents = `
        <script setup>
        import { computed } from "vue"
        import { Example, PropsTable, PageTitle } from "@viteplay/vue"
        import { useRoute, useRouter } from "vue-router"
            
        let componentProps = ${JSON.stringify(componentProps)}
        let route = useRoute()
        let router = useRouter()
        let focusId = computed(() => route.query.focus && route.hash.slice(1))
        let shouldRender = (slug) => {
          return !route.query.focus || slug === focusId.value
        }
        let hiddenCount = computed(() => {
          return ${JSON.stringify(examples.map((example) => example.slug))}.filter((slug) => !shouldRender(slug)).length
        })

        let showAll = () => {
          router.push({ query: {}, hash: route.hash })
        }

        let openInEditor = (file) => {
           fetch('/__open-in-editor?file=' + encodeURIComponent(file))
        }
        let examples = [
          ${examples.map((example) => {
      return `{
                title: ${JSON.stringify(example.title)},
                slug: ${JSON.stringify(example.slug)},
                docs: ${JSON.stringify({
        content: renderMarkdown(example.parsed.docs.content),
        attrs: example.parsed.docs.attrs
      })},
                // encodeURI because the example will contain html tags
                // which will cause this component to be incorrectly parsed
                code: decodeURI(${JSON.stringify(encodeURI(example.contents))}),
                iframeUrl: ${JSON.stringify(`/__iframe/${example.iframeId}.html`)},
                openInEditor: import.meta.env.DEV 
                  ? () => openInEditor(${JSON.stringify(slash(example.absolutePath))}) 
                  : undefined 
              }`;
    }).join(",")}
        ]
        <\/script>
        <template>
          <PageTitle title="${page.title}" ${options.dev ? `:openInEditor="() => openInEditor('${slash(page.component)}')"` : ``} />
          <div v-if="hiddenCount > 0" class="hidden-examples-info">
            {{ hiddenCount }} example{{ hiddenCount > 1 ? "s" : null }} hidden, <a @click.prevent="showAll" type="button" style="cursor: pointer">show all</a>
          </div>
          <PropsTable componentName="${componentName}" :componentProps="componentProps" />
          <template  
            v-for="example in examples" 
            :key="example.slug">
            <Example 
              v-if="shouldRender(example.slug)"
              :example="example" 
              :componentProps="componentProps" />
          </template>
        </template>

<style scoped>
.hidden-examples-info {
  margin: 20px 0;
}
</style>
      `;
    const component = import_node_path3.default.join(options.cacheDir, `${index}-${(0, import_case_anything2.kebabCase)(page.title)}.vue`);
    outputFileIfChanged(component, contents);
    const slug = (0, import_case_anything2.kebabCase)(page.title);
    return {
      title: page.title,
      path: getPath(slug),
      component,
      props,
      children: examples
    };
  }));
  const sideBarItems = pages.filter((p) => p.children.length > 0).map((p) => {
    const item = {
      text: p.title,
      link: p.path,
      headers: p.children.map((c) => ({
        title: c.title,
        slug: c.slug,
        level: 2
      }))
    };
    if (p.props.length > 0) {
      item.headers.unshift({
        title: "Props",
        slug: "props",
        level: 2
      });
    }
    return item;
  });
  const layoutContents = `
<script setup>
import { RouteLayout, provideConfig } from "@viteplay/vue"

const items = ${JSON.stringify(sideBarItems)}

provideConfig(${JSON.stringify({
    base,
    title: options.title,
    logo: options.logo
  })})
<\/script>

<template>
  <RouteLayout :items="items"  />
</template>
`;
  const layoutComponent = import_node_path3.default.join(options.cacheDir, "AutoGeneratedLayout.vue");
  outputFileIfChanged(layoutComponent, layoutContents);
  const clientContent = `
    let pages = [
      {
        path: "${base}",
        component: () => import("${slash(layoutComponent)}"),
        children: [
          ${pages.map((page) => `{
              title: "${page.title}",
              path: "${page.path}",
              component: () => import("${slash(page.component)}")
            }`).join(",\n")}
        ],
      },
    ]
    export { pages }
    `;
  outputFileIfChanged(import_node_path3.default.join(options.cacheDir, "client.js"), clientContent);
  const viteplayIframeFile = await resolveFile(["viteplay.iframe.js", "viteplay.iframe.ts"], options.root);
  outputFileIfChanged(import_node_path3.default.join(options.cacheDir, "viteplay.iframe.js"), viteplayIframeFile ? `
    export { default } from "${slash(viteplayIframeFile)}"
  ` : `export default {}`);
  if (viteplayIframeFile) {
    watchFiles.add(viteplayIframeFile);
  }
  return { watchFiles, iframes };
};

// src/index.ts
var debug = (0, import_debug.default)(`viteplay:plugin`);
var plugin = (options) => {
  let cacheDir = options.cacheDir ?? ".cache/viteplay";
  let watchFiles = /* @__PURE__ */ new Set();
  let root = process.cwd();
  return [
    {
      name: "viteplay",
      async config(config, env) {
        root = config.root || process.cwd();
        const rootHtmlFile = import_node_path4.default.join(root, "index.html");
        cacheDir = import_node_path4.default.resolve(root, cacheDir);
        debug(`Starting initial build`);
        const dev = env.command === "serve";
        const buildResult = await build(__spreadProps(__spreadValues({}, options), { cacheDir, dev, root }));
        watchFiles = buildResult.watchFiles;
        const input = buildResult.iframes.reduce((res, iframe) => {
          return __spreadProps(__spreadValues({}, res), { [`__iframe/${iframe.id}`]: iframe.filepath });
        }, {});
        input.index = rootHtmlFile;
        return {
          optimizeDeps: {
            exclude: ["@viteplay/vue/client"]
          },
          build: {
            rollupOptions: {
              input
            }
          }
        };
      },
      resolveId(id) {
        if (/^\/?viteplay-cache\//.test(id)) {
          return id.replace(/^\/?viteplay-cache/, cacheDir);
        }
      },
      transformIndexHtml(_, ctx) {
        if (!ctx.server)
          return;
        return [
          {
            tag: "script",
            attrs: { type: "module", src: import_node_path4.default.join(OWN_DIR, "vite-client.js") },
            injectTo: "body"
          }
        ];
      },
      configureServer(server) {
        server.watcher.on("all", async (event, id) => {
          id = slash(import_node_path4.default.resolve(id));
          if (id.startsWith(cacheDir)) {
            return;
          }
          if (event === "change" && !watchFiles.has(id)) {
            return;
          }
          debug(`rebuild: %s %s`, event, id);
          try {
            const buildResult = await build(__spreadProps(__spreadValues({}, options), { cacheDir, dev: true, root }));
            watchFiles = buildResult.watchFiles;
            server.ws.send({
              type: "custom",
              event: "viteplay:clear-error-overlay"
            });
          } catch (error) {
            server.ws.send({
              type: "error",
              err: {
                message: error.message,
                stack: error.stack,
                loc: error.loc,
                frame: error.frame || error.code
              }
            });
            console.error(error);
            process.exitCode = 1;
          }
        });
        server.middlewares.use(async (req, res, next) => {
          if (!req.url)
            return next();
          if (!req.url.startsWith("/__iframe/")) {
            return next();
          }
          try {
            const iframeId = req.url.replace("/__iframe/", "").replace(".html", "");
            const html = getIframeHtml(iframeId, cacheDir);
            const result = await server.transformIndexHtml(req.url, html);
            res.setHeader("content-type", "text/html");
            res.end(result);
          } catch (error) {
            next(error);
          }
        });
      }
    },
    {
      name: "viteplay:move-html",
      enforce: "post",
      generateBundle(_, bundle) {
        for (const k of Object.keys(bundle)) {
          const file = bundle[k];
          if (file.type === "asset" && k.includes("/__iframe/") && k.endsWith(".html")) {
            delete bundle[k];
            const fileName = `__iframe/${import_node_path4.default.basename(k)}`;
            this.emitFile({
              type: "asset",
              source: file.source,
              fileName
            });
          }
        }
      }
    }
  ];
};
var src_default = plugin;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
