function debounce(fn, n = 100) {
  let handle;
  return (...args) => {
    if (handle)
      clearTimeout(handle);
    handle = setTimeout(() => {
      fn(...args);
    }, n);
  };
}
function ensureSFC(code) {
  if (!code.includes("<\/script>") && !code.includes("</template>")) {
    code = `<template>${code}</template>`;
  }
  return code;
}
function elOrParentsHaveClass(element, classNameRegex) {
  do {
    if (element && "className" in element && classNameRegex.exec(element.className)) {
      return true;
    }
    element = element && "parentNode" in element ? element == null ? void 0 : element.parentNode : void 0;
  } while (element);
  return false;
}
export { ensureSFC as a, debounce as d, elOrParentsHaveClass as e };
