import { CodeGen } from '@volar/code-gen';
import * as CompilerDOM from '@vue/compiler-dom';
import { EmbeddedFileMappingData } from '../types';
export declare const transformContext: CompilerDOM.TransformContext;
export declare function isIntrinsicElement(runtimeMode: "runtime-dom" | "runtime-uni-app" | undefined, tag: string): boolean;
export declare function generate(ts: typeof import('typescript/lib/tsserverlibrary'), sourceLang: string, templateAst: CompilerDOM.RootNode, isVue2: boolean, experimentalRuntimeMode: 'runtime-dom' | 'runtime-uni-app' | undefined, allowTypeNarrowingInEventExpressions: boolean, cssScopedClasses: string[] | undefined, htmlToTemplate: (htmlStart: number, htmlEnd: number) => {
    start: number;
    end: number;
} | undefined, searchTexts: {
    getEmitCompletion(tag: string): string;
    getPropsCompletion(tag: string): string;
}): {
    codeGen: CodeGen<EmbeddedFileMappingData>;
    formatCodeGen: CodeGen<EmbeddedFileMappingData>;
    cssCodeGen: CodeGen<EmbeddedFileMappingData>;
    tagNames: Record<string, {
        rawComponent: string;
        slotsComponent: string;
        emit: string;
        slots: string;
        offsets: number[];
    }>;
    attrNames: Set<string>;
    identifiers: Set<string>;
};
export declare function getPatchForSlotNode(node: CompilerDOM.ElementNode): CompilerDOM.ForNode | undefined;
